#!/usr/bin/env python3
# -*- coding:utf-8 -*-
import webiopi							
import datetime
import json
import sys
import time
import os
import subprocess
import re
import smbus

# отправка e-mail:
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEBase
from email.mime.multipart import MIMEMultipart
from email.mime.image import MIMEImage
from email.mime.audio import MIMEAudio
from email.header import Header
from base64 import encodebytes
import email
import mimetypes



from subprocess import call
from time import strftime
# Инициализация датчика BMP085
from webiopi.devices.sensor.bmp085 import BMP085
from webiopi.devices.sensor.onewiretemp import DS18B20

GPIO = webiopi.GPIO

GPIO.setFunction(21, GPIO.OUT)						# ВЫХОД ТЕРМОСТАТА 1
GPIO.setFunction(20, GPIO.OUT) 						# ВЫХОД ТЕРМОСТАТА 2
GPIO.setFunction(16, GPIO.OUT)
GPIO.setFunction(12, GPIO.OUT)
GPIO.setFunction(7, GPIO.OUT)	
GPIO.setFunction(8, GPIO.OUT)	
GPIO.setFunction(25, GPIO.OUT)	
GPIO.setFunction(24, GPIO.OUT)	
	
GPIO.setFunction(23, GPIO.IN)	
GPIO.setFunction(18, GPIO.IN)		
GPIO.setFunction(22, GPIO.IN)	
GPIO.setFunction(5, GPIO.IN)	
GPIO.setFunction(6, GPIO.IN)	
GPIO.setFunction(13, GPIO.IN)	
GPIO.setFunction(19, GPIO.IN)	
GPIO.setFunction(26, GPIO.IN)

GPIO.setFunction(10, GPIO.IN,GPIO.PUD_UP)	
GPIO.setFunction(9, GPIO.IN,GPIO.PUD_UP)	
GPIO.setFunction(11, GPIO.IN,GPIO.PUD_UP)		
	
	
# флаг записи старта/рестата WebIOPi
start = 0	
# входы
	 
INPUT_1 = 23
INPUT_2 = 18
INPUT_3 = 22
INPUT_4 = 5
INPUT_5 = 6
INPUT_6 = 13
INPUT_7 = 19
INPUT_8 = 26

#выходы

OUT_1 = 21 
OUT_2 = 20
OUT_3 = 16
OUT_4 = 12 
OUT_5 = 7
OUT_6 = 8
OUT_7 = 25 
OUT_8 = 24


	
# Чтение строк кофигурационного файла в список 
def read_cfg():
    f = open('/home/pi/myproject/html/logs/config.txt', 'r')
    str_cfg = [line.strip() for line in f]
    f.close()
    return str_cfg

# Чтение строк  файла флагов состояния в список 
def read_cfg_tmp():
    if os.path.exists('/home/pi/myproject/html/logs/config_tmp.txt'):
   # файл существует
        f = open('/home/pi/myproject/html/logs/config_tmp.txt', 'r')
        str_cfg = [line.strip() for line in f]
        f.close()
    else: # Если файла нет
        f = open('/home/pi/myproject/html/logs/config_tmp.txt', 'w')
        str_cfg = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
        f.writelines("%s\n" % i for i in str_cfg)
        f.close()
    if os.path.getsize('/home/pi/myproject/html/logs/config_tmp.txt') == 0: # если файл испорчен
        f = open('/home/pi/myproject/html/logs/config_tmp.txt', 'w')
        str_cfg = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
        f.writelines("%s\n" % i for i in str_cfg)
        f.close()
    return str_cfg

# Запись флагов состояния
def write_cfg_tmp(num_str_cfg, str_command):
    f =open('/home/pi/myproject/html/logs/config_tmp.txt','r')     
    line = f.readlines()                                           
    line[int(num_str_cfg)] = str_command+'\n'                             
    f.close()                                                      
    f =open('/home/pi/myproject/html/logs/config_tmp.txt','w')         
    f.writelines(line)                                             
    f.close()      
    

# Отклюние выходов
def set_out():	
    if int(str_cfg[0]) == 0:
        GPIO.digitalWrite(21, GPIO.HIGH)	
    if int(str_cfg[3]):
        GPIO.digitalWrite(20, GPIO.HIGH)
    if int(str_cfg[30]) == 0:
        GPIO.digitalWrite(7, GPIO.HIGH)		
    if int(str_cfg[6]) == 0:
        GPIO.digitalWrite(25, GPIO.HIGH)	
    if int(str_cfg[7]) == 0:
        GPIO.digitalWrite(24, GPIO.HIGH)	

str_cfg = read_cfg()
tmp1 = DS18B20(slave=str_cfg[49])
tmp2 = DS18B20(slave=str_cfg[50])


def setup():
    global str_cfg, str_cfg_tmp 
    str_cfg = read_cfg()
    str_cfg_tmp = read_cfg_tmp()

	
def loop():

    setup()
#============================ КОНТРОЛЬ СТАРТА (РЕСТАРТА ====================================

    global start
    if start == 0:
        text_1 = " Restart Web Home Pi"	
        writing_input()
        start = 1
 

#============================ КОНТРОЛЬ ВХОДОВ ====================================

    global  mail_text 

		
	
# Вход 1===================================
	
    if (int(GPIO.digitalRead(INPUT_1))) == 0:   # контроль входа 1
        write_cfg_tmp('17', '0')
        if int(str_cfg_tmp[16]) == 0:
            text_1 = " Input 1 Close"	
            writing_input()
            if int(str_cfg_tmp[8]) == 1:
                mail_text = str_cfg[59]		
                sendmail()
            write_cfg_tmp('16', '1')

		
    if (int(GPIO.digitalRead(INPUT_1))) == 1:
        write_cfg_tmp('16', '0')
        if int(str_cfg_tmp[17]) == 0:
            text_1 = " Input 1 Open"	
            writing_input()
            if int(str_cfg_tmp[9]) == 1:
                mail_text = str_cfg[60]			
                sendmail()			
            write_cfg_tmp('17', '1')
		
# Вход 2===================================
	
    if (int(GPIO.digitalRead(INPUT_2))) == 0:   # контроль входа 2
        write_cfg_tmp('19', '0')
        if int(str_cfg_tmp[18]) == 0:
            text_1 = " Input 2 Close"	
            writing_input()
            if int(str_cfg_tmp[10]) == 1:
                mail_text = str_cfg[61]			
                sendmail()			
            write_cfg_tmp('18', '1')

		
    if (int(GPIO.digitalRead(INPUT_2))) == 1:
        write_cfg_tmp('18', '0')
        if int(str_cfg_tmp[19]) == 0:
            text_1 = " Input 2 Open"	
            writing_input()
            if int(str_cfg_tmp[11]) == 1:
                mail_text = str_cfg[62]
                sendmail()				
            write_cfg_tmp('19', '1')

	
	
# Вход 3===================================
	
    if (int(GPIO.digitalRead(INPUT_3))) == 0:   # контроль входа 3
        write_cfg_tmp('21', '0')
        if int(str_cfg_tmp[20]) == 0:
            text_1 = " Input 3 Close"	
            writing_input()
            if int(str_cfg_tmp[12]) == 1:
                mail_text = str_cfg[63]			
                sendmail()				
            write_cfg_tmp('20', '1')
	
		
    if (int(GPIO.digitalRead(INPUT_3))) == 1:
        write_cfg_tmp('20', '0')
        if int(str_cfg_tmp[21]) == 0:
            text_1 = " Input 3 Open"	
            writing_input()
            if int(str_cfg_tmp[13]) == 1:
                mail_text = str_cfg[64]
                sendmail()				
            write_cfg_tmp('21', '1')

	
# Вход 4===================================
	
    if (int(GPIO.digitalRead(INPUT_4))) == 0:   # контроль входа 4
        write_cfg_tmp('23', '0')
        if int(str_cfg_tmp[22]) == 0:
            text_1 = " Input 4 Close"	
            writing_input()
            if int(str_cfg_tmp[14]) == 1:
                mail_text = str_cfg[65]
                sendmail()			
            write_cfg_tmp('22', '1')
	
		
    if (int(GPIO.digitalRead(INPUT_4))) == 1:
        write_cfg_tmp('22', '0')
        if int(str_cfg_tmp[23]) == 0:
            text_1 = " Input 4 Open"	
            writing_input()
            if int(str_cfg_tmp[15]) == 1:
                mail_text = str_cfg[66]
                sendmail()			
            write_cfg_tmp('23', '1')

	
# Вход 5===================================
	
    if (int(GPIO.digitalRead(INPUT_5))) == 0:   # контроль входа 5
        write_cfg_tmp('25', '0')
        if int(str_cfg_tmp[24]) == 0:
            text_1 = " Input 5 Close"	
            writing_input()
            if int(str_cfg_tmp[16]) == 1:
                mail_text = str_cfg[67]
                sendmail()			
            write_cfg_tmp('24', '1')

		
    if (int(GPIO.digitalRead(INPUT_5))) == 1:
        write_cfg_tmp('24', '0')
        if int(str_cfg_tmp[25]) == 0:
            text_1 = " Input 5 Open"	
            writing_input()
            if int(str_cfg_tmp[17]) == 1:
                mail_text = str_cfg[68]
                sendmail()				
            write_cfg_tmp('25', '1')
	
	
# Вход 6===================================
	
    if (int(GPIO.digitalRead(INPUT_6))) == 0:   # контроль входа 6
        write_cfg_tmp('27', '0')
        if int(str_cfg_tmp[26]) == 0:
            text_1 = " Input 6 Close"	
            writing_input()
            if int(str_cfg_tmp[18]) == 1:
                mail_text = str_cfg[69]
                sendmail()			
            write_cfg_tmp('26', '1')
	
		
    if (int(GPIO.digitalRead(INPUT_6))) == 1:
        write_cfg_tmp('26', '0')
        if int(str_cfg_tmp[27]) == 0:
            text_1 = " Input 6 Open"	
            writing_input()
            if int(str_cfg_tmp[19]) == 1:
                mail_text = str_cfg[70]
                sendmail()			
            write_cfg_tmp('27', '1')
	
	
# Вход 7===================================
    if int(str_cfg[6]) == 0:
        if (int(GPIO.digitalRead(INPUT_7))) == 0:   # контроль входа 7
            write_cfg_tmp('29', '0')
            if int(str_cfg_tmp[28]) == 0:
                text_1 = " Input 7 Close"	
                writing_input()
                if int(str_cfg_tmp[20]) == 1:
                    mail_text = str_cfg[71]
                    sendmail()				
                write_cfg_tmp('28', '1')
	
    if int(str_cfg[6]) == 0:		
        if (int(GPIO.digitalRead(INPUT_7))) == 1:
            write_cfg_tmp('28', '0')
            if int(str_cfg_tmp[29]) == 0:
                text_1 = " Input 7 Open"	
                writing_input()
                if int(str_cfg_tmp[21]) == 1:
                    mail_text = str_cfg[72]
                    sendmail()				
                write_cfg_tmp('29', '1')

# Вход 8===================================
	
    if int(str_cfg[7]) == 0:
        if (int(GPIO.digitalRead(INPUT_8))) == 0:   # контроль входа 8
            write_cfg_tmp('31', '0')
            if int(str_cfg_tmp[30]) == 0:
                text_1 = " Input 8 Close"	
                writing_input()
                if int(str_cfg_tmp[22]) == 1:
                    mail_text = str_cfg[73]
                    sendmail()				
                write_cfg_tmp('30', '1')
	
    if int(str_cfg[7]) == 0:		
        if (int(GPIO.digitalRead(INPUT_8))) == 1:
            write_cfg_tmp('30', '0')
            if int(str_cfg_tmp[31]) == 0:
                text_1 = " Input 8 Open"	
                writing_input()
                if int(str_cfg_tmp[23]) == 1:
                    mail_text = str_cfg[74]
                    sendmail()				
                write_cfg_tmp('31', '1')



	
# =================================КОНТРОЛЬ ВХОДОВ 7 И 8 С ПРИВЯЗКОЙ К ВЫХОДАМ 7 И 8	
	
    
	
# Вход 7+++++===================================
    if int(str_cfg[6]) == 1:	
        if (int(GPIO.digitalRead(INPUT_7))) == 0:   		# контроль входа 7 с включением реле
            write_cfg_tmp('41', '0')
            value = int(0)		
            GPIO.digitalWrite(25,value)          		# записать в порт OUT_7 значение value 
            if int(str_cfg_tmp[40]) == 0:
                text_1 = " Input 7 Close / Relay 7 ON"	
                writing_input()
                write_cfg_tmp('40', '1')
                if int(str_cfg_tmp[20]) == 1:
                    mail_text = str_cfg[71]				
                    sendmail()


		
		
    if int(str_cfg[6]) == 1:
        if (int(GPIO.digitalRead(INPUT_7))) == 1:   		# контроль входа 7 с включением реле
            write_cfg_tmp('40', '0')
            value = int(1)		
            GPIO.digitalWrite(25,value)          		# записать в порт OUT_7 значение value 
            if int(str_cfg_tmp[41]) == 0:
                text_1 = " Input 7 Open  / Relay 7 OFF"	
                writing_input()
                write_cfg_tmp('41', '1')
                if int(str_cfg_tmp[21]) == 1:
                    mail_text = str_cfg[72]
                    sendmail()

		
				

# Вход 8+++++===================================

    if int(str_cfg[7]) == 1:
        if (int(GPIO.digitalRead(INPUT_8))) == 0:   		# контроль входа 8 с включением реле
            write_cfg_tmp('43', '0')
            value = int(0)		
            GPIO.digitalWrite(24,value)          		# записать в порт OUT_8 значение value 
            if int(str_cfg_tmp[42]) == 0:
                text_1 = " Input 8 Close / Relay 8 ON"	
                writing_input()
                write_cfg_tmp('42', '1')
                if int(str_cfg_tmp[22]) == 1:
                    mail_text = str_cfg[73]
                    sendmail()


		
    if int(str_cfg[7]) == 1:	
        if (int(GPIO.digitalRead(INPUT_8))) == 1:   		# контроль входа 8 с включением реле
            write_cfg_tmp('42', '0')
            value = int(1)		
            GPIO.digitalWrite(24,value)          		# записать в порт OUT_8 значение value 
            if int(str_cfg_tmp[43]) == 0:
                text_1 = " Input 8 Open  / Relay 8 OFF"	
                writing_input()
                write_cfg_tmp('43', '1')
                if int(str_cfg_tmp[23]) == 1:
                    mail_text = str_cfg[74]
                    sendmail()

		

	
	
#============================ КОНТРОЛЬ ВЫХОДОВ (для записи в журнал событий) ====================================	

    global text_1


# Выход 1+контроль привязки к термостату ===================================
	
    if int(str_cfg[0]) == 0:
        if (int(GPIO.digitalRead(OUT_1))) == 0:  
            write_cfg_tmp('1', '0')	
            if int(str_cfg_tmp[0]) == 0:
                text_1 = " Relay 1 ON "	
                writing_out() 
                write_cfg_tmp('0', '1')		

    if int(str_cfg[0]) == 0:
        if (int(GPIO.digitalRead(OUT_1))) == 1:
            write_cfg_tmp('0', '0')		
            if int(str_cfg_tmp[1]) == 0:
                text_1 = " Relay 1 OFF"	
                writing_out()	
                write_cfg_tmp('1', '1')
	 
		 
# Выход 2+контроль привязки к термомтату ===================================

    if int(str_cfg[3]) == 0:
        if (int(GPIO.digitalRead(OUT_2))) == 0:   
            write_cfg_tmp('3', '0')		
            if int(str_cfg_tmp[2]) == 0:
                text_1 = " Relay 2 ON "	
                writing_out()	
                write_cfg_tmp('2', '1')
				
    if int(str_cfg[3]) == 0:
        if (int(GPIO.digitalRead(OUT_2))) == 1:
            write_cfg_tmp('2', '0')		
            if int(str_cfg_tmp[3]) == 0:
                text_1 = " Relay 2 OFF"	
                writing_out()
                write_cfg_tmp('3', '1')	

# Выход 3 + таймер ===================================
	
    if (int(GPIO.digitalRead(OUT_3))) == 0: 
        write_cfg_tmp('5', '0')
        if int(str_cfg_tmp[4]) == 0:
            if int(str_cfg[24]) == 1:
                text_1 = " Relay 3 ON  / Timer start"
            else:
                text_1 = " Relay 3 ON"				
            writing_out()	
            write_cfg_tmp('4', '1')
			
    if (int(GPIO.digitalRead(OUT_3))) == 1:
        write_cfg_tmp('4', '0')	
        if int(str_cfg_tmp[5]) == 0:
            if int(str_cfg[24]) == 1:
                text_1 = " Relay 3 OFF / Timer stop"	
            else:
                text_1 = " Relay 3 OFF"	
            writing_out()	
            write_cfg_tmp('5', '1')			 
		 
# Выход 4 + таймер ===================================
	
    if (int(GPIO.digitalRead(OUT_4))) == 0: 
        write_cfg_tmp('7', '0')	
        if int(str_cfg_tmp[6]) == 0:
            if int(str_cfg[27]) == 1:
                text_1 = " Relay 4 ON  / Timer start"
            else:
                text_1 = " Relay 4 ON"	
            writing_out()	
            write_cfg_tmp('6', '1')	
			
    if (int(GPIO.digitalRead(OUT_4))) == 1:
        write_cfg_tmp('6', '0')	
        if int(str_cfg_tmp[7]) == 0:
            if int(str_cfg[27]) == 1:
                text_1 = " Relay 4 OFF / Timer stop"	
            else:
                text_1 = " Relay 4 OFF"	
            writing_out()	
            write_cfg_tmp('7', '1')				 
	 
	 
# Выход 5 + люксметр ===================================

    if int(str_cfg[30]) == 0:	
        if (int(GPIO.digitalRead(OUT_5))) == 0:
            write_cfg_tmp('9', '0') 
            if int(str_cfg_tmp[8]) == 0:
                text_1 = " Relay 5 ON "	
                writing_out()	
                write_cfg_tmp('8', '1')

    if int(str_cfg[30]) == 0:					
        if (int(GPIO.digitalRead(OUT_5))) == 1:
            write_cfg_tmp('8', '0')
            if int(str_cfg_tmp[9]) == 0:
                text_1 = " Relay 5 OFF"	
                writing_out()	
                write_cfg_tmp('9', '1')		 
	 
	 
# Выход 6 ===================================
	
    if (int(GPIO.digitalRead(OUT_6))) == 0: 
        write_cfg_tmp('11', '0')	
        if int(str_cfg_tmp[10]) == 0:
            text_1 = " Relay 6 ON"	
            writing_out()	
            write_cfg_tmp('10', '1')
			
    if (int(GPIO.digitalRead(OUT_6))) == 1:
        write_cfg_tmp('10', '0')	
        if int(str_cfg_tmp[11]) == 0:
            text_1 = " Relay 6 OFF"	
            writing_out()	
            write_cfg_tmp('11', '1')		 

# Выход 7+контроль привязки к входу 7 ===================================
	
    if (int(GPIO.digitalRead(OUT_7))) == 0:
        write_cfg_tmp('13', '0') 
        if int(str_cfg_tmp[12]) == 0:
            if int(str_cfg[6]) == 0:
                text_1 = " Relay 7 ON"	
                writing_out()	
                write_cfg_tmp('12', '1')
            if int(str_cfg[6]) == 1:
                #text_1 = " Relay 7 ON  / Input 7 Close"	
                #writing_out()	
                 write_cfg_tmp('12', '1')
				
			
    if (int(GPIO.digitalRead(OUT_7))) == 1:
        write_cfg_tmp('12', '0') 
        if int(str_cfg_tmp[13]) == 0:
            if int(str_cfg[6]) == 0:
                text_1 = " Relay 7 OFF"	
                writing_out()	
                write_cfg_tmp('13', '1')		
            if int(str_cfg[6]) == 1:
                #text_1 = " Relay 7 OFF / Input 7 Open"	
                #writing_out()	
                 write_cfg_tmp('13', '1')	 
	 	 
	 
# Выход 8+контроль привязки к входу 8 ===================================
	
    if (int(GPIO.digitalRead(OUT_8))) == 0:
        write_cfg_tmp('15', '0')  
        if int(str_cfg_tmp[14]) == 0:
            if int(str_cfg[7]) == 0:
                text_1 = " Relay 8 ON"	
                writing_out()	
                write_cfg_tmp('14', '1')
            if int(str_cfg[7]) == 1:
                #text_1 = " Relay 8 ON  / Input 8 Close"	
                #writing_out()	
                write_cfg_tmp('14', '1')			
			
			
			
    if (int(GPIO.digitalRead(OUT_8))) == 1:
        write_cfg_tmp('14', '0') 
        if int(str_cfg_tmp[15]) == 0:
            if int(str_cfg[7]) == 0:
                text_1 = " Relay 8 OFF"	
                writing_out()	
                write_cfg_tmp('15', '1')		 
            if int(str_cfg[7]) == 1:
                #text_1 = " Relay 8 OFF / Input 8 Open"	
                #writing_out()	
                write_cfg_tmp('15', '1')							
					

#============================ ТЕРМОСТАТ НА ! и 2 ВЫХОДАХ =======================

    global celsius_1, celsius_2, temp_log
	

	
#============================ ПЕРВЫЙ ДАТЧИК	ТЕРМОСТАТА РЕЛЕ К1
    if int(str_cfg[0]) == 1:
        celsius_1 = tmp1.getCelsius() 
        celsius_1 = float(celsius_1)	
        if celsius_1 < float(str_cfg[1]): 
            GPIO.digitalWrite(21, GPIO.LOW)
            write_cfg_tmp('33', '0')
            if int(str_cfg_tmp[32]) == 0:
                text_1 = " Relay 1 ON  / Temperature"	
                temp_log = celsius_1
                writing_temp()
                write_cfg_tmp('32', '1')

    if int(str_cfg[0]) == 1:
        celsius_1 = tmp1.getCelsius() 
        celsius_1 = float(celsius_1)	
        if celsius_1 > float(str_cfg[2]): 
            GPIO.digitalWrite(21, GPIO.HIGH)
            write_cfg_tmp('32', '0')
            if int(str_cfg_tmp[33]) == 0:
                text_1 = " Relay 1 OFF / Temperature"
                temp_log = celsius_1			
                writing_temp()							
                write_cfg_tmp('33', '1')
	
#============================ ВТОРОЙ ДАТЧИК	ТЕРМОСТАТА РЕЛЕ К2

    if int(str_cfg[3]) == 1:
        celsius_2 = tmp2.getCelsius() 
        celsius_2 = float(celsius_2)	
        if celsius_2 < float(str_cfg[4]): 
            GPIO.digitalWrite(20, GPIO.LOW)
            write_cfg_tmp('35', '0')
            if int(str_cfg_tmp[34]) == 0:
                text_1 = " Relay 2 ON  / Temperature"	
                temp_log = celsius_2
                writing_temp()
                write_cfg_tmp('34', '1')		

	
    if int(str_cfg[3]) == 1:	
        celsius_2 = tmp2.getCelsius() 
        celsius_2 = float(celsius_2)	
        if celsius_2 > float(str_cfg[5]): 
            GPIO.digitalWrite(20, GPIO.HIGH)
            write_cfg_tmp('34', '0')
            if int(str_cfg_tmp[35]) == 0:
                text_1 = " Relay 2 OFF / Temperature"
                temp_log = celsius_2			
                writing_temp()					
                write_cfg_tmp('35', '1')

	
	

	
#============  ПЕРВЫЙ ТАЙМЕР РЕЛЕ К3	
	
    if int(str_cfg[24]) == 1:
        s = str_cfg[25]
        hour_1_start =int(s[0:2])
        minute_1_start = int(s[3:5])
        s = str_cfg[26]
        hour_1_stop = int(s[0:2])
        minute_1_stop = int(s[3:5])
# Данная добавка устраняет баг таймера при переходе на следуюшие сутки
# Например время включения 23:00 время отключениия 02:00 если в интервале от 00:00 до 02:00
# сделать рестарт webiopi то таймер останется в отключеном положении сохранение флагов состояния
# в файле позволяет проконтролировать состояние таймера  
        if ((int(str_cfg_tmp[4]) == 1) and (int(str_cfg_tmp[5]) == 0)):       
            GPIO.digitalWrite(16, GPIO.LOW)                                        
        now = datetime.datetime.now()
        if ((now.hour == hour_1_start) and (now.minute >= minute_1_start)):		    
            GPIO.digitalWrite(16, GPIO.LOW)
        if ((now.hour == hour_1_stop) and (now.minute >= minute_1_stop)):		    
            GPIO.digitalWrite(16, GPIO.HIGH)
	
	
	
#============  ВТРОЙ ТАЙМЕР РЕЛЕ К4	
	
    if int(str_cfg[27]) == 1:
        s = str_cfg[28]
        hour_2_start = int(s[0:2])
        minute_2_start = int(s[3:5])
        s = str_cfg[29]
        hour_2_stop = int(s[0:2])
        minute_2_stop = int(s[3:5])
        if ((int(str_cfg_tmp[6]) == 1) and (int(str_cfg_tmp[7]) == 0)):
            GPIO.digitalWrite(12, GPIO.LOW)  
        now = datetime.datetime.now()
        if ((now.hour == hour_2_start) and (now.minute >= minute_2_start)):		    
            GPIO.digitalWrite(12, GPIO.LOW)			
        if ((now.hour == hour_2_stop) and (now.minute >= minute_2_stop)):	    
            GPIO.digitalWrite(12, GPIO.HIGH)
		
		
	
#============================ ЛЮКСМЕТР РЕЛЕ К5

    global lux_1, lux_log

    if int(str_cfg[30]) == 1:
        getLight() 	
        if lux_1 < float(str_cfg[31]):
            time.sleep(0.250)		
        if lux_1 < float(str_cfg[31]):
            GPIO.digitalWrite(7, GPIO.LOW)
            write_cfg_tmp('37', '0')
            if int(str_cfg_tmp[36]) == 0:
                text_1 = " Relay 5 ON  / Lux"	
                lux_log = lux_1
                writing_lux()
                write_cfg_tmp('36', '1')
		

    if int(str_cfg[30]) == 1:
        getLight() 	
        if lux_1 > float(str_cfg[32]): 
            time.sleep(0.250)
        if lux_1 > float(str_cfg[32]):			
            GPIO.digitalWrite(7, GPIO.HIGH)
            write_cfg_tmp('36', '0')
            if int(str_cfg_tmp[37]) == 0:
                text_1 = " Relay 5 OFF / Lux"
                lux_log = lux_1			
                writing_lux()						
                write_cfg_tmp('37', '1')
	

	
    webiopi.sleep(0.1)
	
	
#===================== TSL 2561		
	
@webiopi.macro
def getLight():
    global lux_1
    try:
        bus = smbus.SMBus(1)
        bus.write_byte_data(0x39, 0x00 | 0x80, 0x03)
        time.sleep(0.5)
			
        data = bus.read_i2c_block_data(0x39, 0x0C | 0x80, 2)
        data1 = bus.read_i2c_block_data(0x39, 0x0E | 0x80, 2)

        ch0 = data[1] * 256 + data[0]
        ch1 = data1[1] * 256 + data1[0]

        lux_1 = ch0 - ch1			
        print (lux_1)
        return "%.1f" % lux_1			
	
    except Exception as e:
        pass			
	
	

#======================================МАКРОСЫ e-Mail===========================

@webiopi.macro
def sendmail():
 
    smtp_port = 587	
    mail_subj = 'Web Home Pi message'	# тема письма
    mail_coding = 'windows-1251'
    attach_file = '/home/pi/myproject/html/logs/log_gpio.txt' # прикрепляемый файл	
	
    
    # формирование сообщения
    try:
        multi_msg = MIMEMultipart()
        multi_msg['From'] = Header(str_cfg[76], mail_coding)
        multi_msg['To'] = Header(str_cfg[75], mail_coding)
        multi_msg['Subject'] =  Header(mail_subj, mail_coding)
 
        msg = MIMEText(mail_text.encode('cp1251'), 'plain', mail_coding)
        msg.set_charset(mail_coding)
        multi_msg.attach(msg)

        # присоединяем атач-файл
        if(os.path.exists(attach_file) and os.path.isfile(attach_file)):
            file = open(attach_file, 'rb')
            attachment = MIMEBase('application', "octet-stream")
            attachment.set_payload(file.read())
            email.encoders.encode_base64(attachment)
            file.close()
            only_name_attach = Header(os.path.basename(attach_file),mail_coding);
            attachment.add_header('Content-Disposition','attachment; filename="%s"' % only_name_attach)
            multi_msg.attach(attachment)
        else:
            if(attach_file.lstrip() != ""):
                print("Файл для атача не найден - " + attach_file)	
	
        # отправка
        smtp = smtplib.SMTP(str_cfg[77], smtp_port)
        smtp.ehlo()
        smtp.starttls()
        smtp.ehlo()
        smtp.login(str_cfg[78], str_cfg[79])
        smtp.sendmail(str_cfg[76], str_cfg[75], multi_msg.as_string())
        smtp.quit()	

	
    except IOError:
        pass
    except Exception as e:
        pass
		
	
#==============================================================
# Запись cостояния выходов при работе термостата
@webiopi.macro
def writing_temp():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1},{2}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1,temp_log)
    f.write(data_entry)
    f.close()

# Запись cостояния выходов при работе люксметра
def writing_lux():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1},{2}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1, "%.1f" % lux_log)
    f.write(data_entry)
    f.close()
	
# Запись cостояния входов
@webiopi.macro
def writing_input():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1)
    f.write(data_entry)
    f.close()

	
# Запись cостояния выходов
@webiopi.macro
def writing_out():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1)
    f.write(data_entry)
    f.close()	
	
	
	
	
	
	

#======================================МАКРОСЫ ВВОДА И ЧТЕНИЯ ДАННЫХ КОНФИГУРАЦИИ===========================

#=========== ввод данных конфигурации

@webiopi.macro	
def getMinMax(ust_1_on,ust_1_min,ust_1_max,ust_2_on,ust_2_min,ust_2_max,on_out_7,on_out_8,\
    in_1_mail_close,in_1_mail_open,in_2_mail_close,in_2_mail_open,in_3_mail_close,in_3_mail_open,in_4_mail_close,in_4_mail_open,\
    in_5_mail_close,in_5_mail_open,in_6_mail_close,in_6_mail_open,in_7_mail_close,in_7_mail_open,in_8_mail_close,in_8_mail_open,\
    time_1_on,time_1_start,time_1_stop,time_2_on,time_2_start,time_2_stop,lux_1_on,lux_1_start,lux_1_stop,\
    sensor_1,sensor_2,sensor_3,sensor_4,sensor_5,sensor_6,sensor_7,sensor_8,\
    sensor_9,sensor_10,sensor_11,sensor_12,sensor_13,sensor_14,sensor_15,sensor_16,\
    id_18b20_1,id_18b20_2,id_18b20_3,id_18b20_4,id_18b20_5,id_18b20_6,id_18b20_7,id_18b20_8,id_18b20_9,id_18b20_10,\
    text_mail_1_close,text_mail_1_open,text_mail_2_close,text_mail_2_open,text_mail_3_close,text_mail_3_open,text_mail_4_close,text_mail_4_open,\
    text_mail_5_close,text_mail_5_open,text_mail_6_close,text_mail_6_open,text_mail_7_close,text_mail_7_open,text_mail_8_close,text_mail_8_open,\
    mail_to,mail_from,smtp_server,smtp_user,smtp_pwd,\
    reserve,ch_1,ch_2,ch_3,ch_4,ch_5,ch_6,ch_7,ch_8,\
    icon_index,icon_gpio,icon_radio,icon_meteo,icon_controllers,icon_graphs,icon_config,icon_logs):	

	
    f = open('/home/pi/myproject/html/logs/config.txt', 'w')
    f.write((ust_1_on) + "\n")
    f.write((ust_1_min) + "\n")	
    f.write((ust_1_max) + "\n")	
    f.write((ust_2_on) + "\n")
    f.write((ust_2_min) + "\n")	
    f.write((ust_2_max) + "\n")		
    f.write((on_out_7) + "\n")		
    f.write((on_out_8) + "\n")	
	
    f.write((in_1_mail_close) + "\n")		
    f.write((in_1_mail_open) + "\n")		
    f.write((in_2_mail_close) + "\n")		
    f.write((in_2_mail_open) + "\n")
    f.write((in_3_mail_close) + "\n")		
    f.write((in_3_mail_open) + "\n")		
    f.write((in_4_mail_close) + "\n")		
    f.write((in_4_mail_open) + "\n")

    f.write((in_5_mail_close) + "\n")		
    f.write((in_5_mail_open) + "\n")		
    f.write((in_6_mail_close) + "\n")		
    f.write((in_6_mail_open) + "\n")
    f.write((in_7_mail_close) + "\n")		
    f.write((in_7_mail_open) + "\n")		
    f.write((in_8_mail_close) + "\n")		
    f.write((in_8_mail_open) + "\n")
	
    f.write((time_1_on) + "\n")	
    f.write((time_1_start) + "\n")	
    f.write((time_1_stop) + "\n")

    f.write((time_2_on) + "\n")	
    f.write((time_2_start) + "\n")	
    f.write((time_2_stop) + "\n")

    f.write((lux_1_on) + "\n")	
    f.write((lux_1_start) + "\n")	
    f.write((lux_1_stop) + "\n")
	
    f.write((sensor_1) + "\n")	
    f.write((sensor_2) + "\n")	
    f.write((sensor_3) + "\n")	
    f.write((sensor_4) + "\n")	
    f.write((sensor_5) + "\n")	
    f.write((sensor_6) + "\n")	
    f.write((sensor_7) + "\n")	
    f.write((sensor_8) + "\n")
    f.write((sensor_9) + "\n")	
    f.write((sensor_10) + "\n")	
    f.write((sensor_11) + "\n")	
    f.write((sensor_12) + "\n")	
    f.write((sensor_13) + "\n")	
    f.write((sensor_14) + "\n")	
    f.write((sensor_15) + "\n")	
    f.write((sensor_16) + "\n")	
	
    f.write((id_18b20_1) + "\n")
    f.write((id_18b20_2) + "\n")	
    f.write((id_18b20_3) + "\n")
    f.write((id_18b20_4) + "\n")	
    f.write((id_18b20_5) + "\n")
    f.write((id_18b20_6) + "\n")
    f.write((id_18b20_7) + "\n")
    f.write((id_18b20_8) + "\n")
    f.write((id_18b20_9) + "\n")
    f.write((id_18b20_10) + "\n")	
	
    f.write((text_mail_1_close) + "\n")	
    f.write((text_mail_1_open) + "\n")	
    f.write((text_mail_2_close) + "\n")	
    f.write((text_mail_2_open) + "\n")	
    f.write((text_mail_3_close) + "\n")	
    f.write((text_mail_3_open) + "\n")	
    f.write((text_mail_4_close) + "\n")	
    f.write((text_mail_4_open) + "\n")			
    f.write((text_mail_5_close) + "\n")	
    f.write((text_mail_5_open) + "\n")	
    f.write((text_mail_6_close) + "\n")	
    f.write((text_mail_6_open) + "\n")		
    f.write((text_mail_7_close) + "\n")	
    f.write((text_mail_7_open) + "\n")	
    f.write((text_mail_8_close) + "\n")	
    f.write((text_mail_8_open) + "\n")		
	
    f.write((mail_to) + "\n")		
    f.write((mail_from) + "\n")	
    f.write((smtp_server) + "\n")	
    f.write((smtp_user) + "\n")	
    f.write((smtp_pwd) + "\n")	
	
    f.write((reserve) + "\n")
		
    f.write((ch_1) + "\n")		
    f.write((ch_2) + "\n")	
    f.write((ch_3) + "\n")	
    f.write((ch_4) + "\n")	
    f.write((ch_5) + "\n")	
    f.write((ch_6) + "\n")	
    f.write((ch_7) + "\n")	
    f.write((ch_8) + "\n")	
	
    f.write((icon_index) + "\n")		
    f.write((icon_gpio) + "\n")	
    f.write((icon_radio) + "\n")	
    f.write((icon_meteo) + "\n")	
    f.write((icon_controllers) + "\n")	
    f.write((icon_graphs) + "\n")
    f.write((icon_logs) + "\n")		
    f.write((icon_config) + "\n")	

	
    f.close()
	
    setup()		
    set_out()


#=========== чтение данных конфигурации


@webiopi.macro
def getRead():
    f = open('/home/pi/myproject/html/logs/config.txt', 'r')
    lista = [line.strip() for line in f]
    f.close()
    return json.dumps (lista)
	
	
#=========== чтение напоминаний	
	
@webiopi.macro		
def getMessage():
    f = open('/home/pi/myproject/html/logs/message.txt', 'r')
    global message_1 	
    if int(str_cfg[24]) == 1:	
        now = datetime.datetime.now()
        if ((now.hour == hour_1_start) and (now.minute >= minute_1_start)):		    
            message_1 = f.readline()
            f.close()	
            print(message_1)	
            return message_1			



#=========== чтение журнала
	
@webiopi.macro		
def getLogs():
    global logs_gpio	
    f = open('/home/pi/myproject/html/logs/log_gpio.txt')
    logs_gpio = f.readlines()
    print(logs_gpio)
    return logs_gpio
    f.close()

		
	
# ============== очистка журналов логов

@webiopi.macro	
def clear_log_gpio():
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'w')	
    f.write()		
    f.close()	
	

# ============== рестарт webiopi
@webiopi.macro
def restart_webiopi():
    os.system("sudo systemctl restart webiopi.service")		