﻿#!/usr/bin/env python3
# -*- coding:utf-8 -*-
import os
import io
import sys
import shutil
import string
import random
import webiopi
import smbus
import time
import Adafruit_DHT


from webiopi.devices.sensor.bmp085 import BMP085
from webiopi.devices.sensor.onewiretemp import DS18B20
from time import strftime

GPIO = webiopi.GPIO

GPIO.setFunction(21, GPIO.OUT)						
GPIO.setFunction(20, GPIO.OUT) 						
GPIO.setFunction(16, GPIO.OUT)
GPIO.setFunction(12, GPIO.OUT)
GPIO.setFunction(7, GPIO.OUT)	
GPIO.setFunction(8, GPIO.OUT)	
GPIO.setFunction(25, GPIO.OUT)	
GPIO.setFunction(24, GPIO.OUT)	
	
GPIO.setFunction(23, GPIO.IN)	
GPIO.setFunction(18, GPIO.IN)		
GPIO.setFunction(22, GPIO.IN)	
GPIO.setFunction(5, GPIO.IN)	
GPIO.setFunction(6, GPIO.IN)	
GPIO.setFunction(13, GPIO.IN)	
GPIO.setFunction(19, GPIO.IN)	
GPIO.setFunction(26, GPIO.IN)

folder_log = '/home/pi/myproject/html/logs/'      # Каталог с логами
folder_receive_sms = '/var/spool/sms/incoming/'		# Каталог с принятыми смс
folder_send_sms = '/var/spool/sms/outgoing/'		  # Каталог с смс на отправку


# Создание строки смс с показателями датчиков кросс платы
def str_sms_info1():
    global pressure, D22_T, D22_H,  D22_T2, D22_H2, celsius_1, celsius_2, celsius_3, celsius_4, celsius_5, celsius_6, celsius_7, celsius_8, lux_0
    file_cfg =open('/home/pi/myproject/html/logs/config.txt','r')       # Открытие файла конфигурации
    tmp_cfg = file_cfg.readlines()                                      # Чтение всех строк файла конфигурации                                      
    id_18b20_1 = tmp_cfg[49]                                            # id датчика DS18B20 № 1
    id_18b20_1 = id_18b20_1.rstrip()		
    id_18b20_2 = tmp_cfg[50]
    id_18b20_2 = id_18b20_2.rstrip()
    id_18b20_3 = tmp_cfg[51]
    id_18b20_3 = id_18b20_3.rstrip()
    id_18b20_4 = tmp_cfg[52]
    id_18b20_4 = id_18b20_4.rstrip()
    id_18b20_5 = tmp_cfg[53]
    id_18b20_5 = id_18b20_5.rstrip()
    id_18b20_6 = tmp_cfg[54]
    id_18b20_6 = id_18b20_6.rstrip()
    id_18b20_7 = tmp_cfg[55]
    id_18b20_7 = id_18b20_7.rstrip()
    id_18b20_8 = tmp_cfg[56]
    id_18b20_8 = id_18b20_8.rstrip()                                    # id датчика DS18B20 № 8
    tmp1 = DS18B20(slave=id_18b20_1)
    tmp2 = DS18B20(slave=id_18b20_2)
    tmp3 = DS18B20(slave=id_18b20_3)
    tmp4 = DS18B20(slave=id_18b20_4)
    tmp5 = DS18B20(slave=id_18b20_5)
    tmp6 = DS18B20(slave=id_18b20_6)	
    tmp7 = DS18B20(slave=id_18b20_7)
    tmp8 = DS18B20(slave=id_18b20_8)
    bmp = BMP085(0x77)                                                  # Чтение атмосферного давление с датчика BMP085
    pressure = bmp.getHectoPascal()	
    pressure = str(round(pressure*0.75, 1))
    str_send_tmp = ' Press='+pressure+'\n'
    if int(tmp_cfg[43]) == 1:
        sensor = Adafruit_DHT.DHT22                                     # Чтение температуры и влажности с датчика DHT22 №1
        pin = 17
        D22_humidity, D22_temperature = Adafruit_DHT.read(sensor, pin)
        if D22_humidity is not None and D22_temperature is not None:
            D22_T = str(round(D22_temperature,1))
            D22_H = str(round(D22_humidity,1))
            str_send_tmp = str_send_tmp+' Hum1='+D22_H+'\n'+' Temp1='+D22_T+'\n'
        else:
            D22_T = '?'
            D22_H = '?'
            str_send_tmp = str_send_tmp+' Hum1='+D22_H+'\n'+' Temp1='+D22_T+'\n'
#        time.sleep(0.5)			
    if int(tmp_cfg[44]) == 1:
        sensor = Adafruit_DHT.DHT22                                      # Чтение температуры и влажности с датчика DHT22 №2
        pin = 27
        D22_humidity_2, D22_temperature_2 = Adafruit_DHT.read(sensor, pin)
        if D22_humidity_2 is not None and D22_temperature_2 is not None:
            D22_T2 = str(round(D22_temperature_2,1))
            D22_H2 = str(round(D22_humidity_2,1))
            str_send_tmp = str_send_tmp+' Hum2='+D22_H2+'\n'+' Temp2='+D22_T2+'\n'
        else:
            D22_T2 = '?'
            D22_H2 = '?'
            str_send_tmp = str_send_tmp+' Hum2='+D22_H2+'\n'+' Temp2='+D22_T2+'\n'
#        time.sleep(0.5)
    if int(tmp_cfg[33]) == 1:
        celsius_1 = tmp1.getCelsius()                                    # Чтение температуры  с датчика DS18B20 № 1
        celsius_1 = str(round(celsius_1, 1))
        str_send_tmp = str_send_tmp+' TempTerm1='+celsius_1+'\n'
    if int(tmp_cfg[34]) == 1:
        celsius_2= tmp2.getCelsius()
        celsius_2= str(round(celsius_2, 1))
        str_send_tmp = str_send_tmp+' TempTerm2='+celsius_2+'\n'
    if int(tmp_cfg[35]) == 1:
        celsius_3 = tmp3.getCelsius()
        celsius_3 = str(round(celsius_3, 1))
        str_send_tmp = str_send_tmp+' Temp3='+celsius_3+'\n'
    if int(tmp_cfg[36]) == 1:
        celsius_4= tmp4.getCelsius()
        celsius_4= str(round(celsius_4, 1))
        str_send_tmp = str_send_tmp+' Temp4='+celsius_4+'\n'
    if int(tmp_cfg[37]) == 1:
        celsius_5 = tmp5.getCelsius()
        celsius_5 = str(round(celsius_5, 1))
        str_send_tmp = str_send_tmp+' Temp5='+celsius_5+'\n'
    if int(tmp_cfg[38]) == 1:
        celsius_6= tmp6.getCelsius()
        celsius_6= str(round(celsius_6, 1))
        str_send_tmp = str_send_tmp+' Temp6='+celsius_6+'\n'
    if int(tmp_cfg[39]) == 1:
        celsius_7 = tmp7.getCelsius()
        celsius_7 = str(round(celsius_7, 1))
        str_send_tmp = str_send_tmp+' Temp7='+celsius_7+'\n'
    if int(tmp_cfg[40]) == 1:
        celsius_8= tmp8.getCelsius()                                      # Чтение температуры  с датчика DS18B20 № 8
        celsius_8= str(round(celsius_8, 1))
        str_send_tmp = str_send_tmp+' Temp8='+celsius_8+'\n'
    if int(tmp_cfg[46]) == 1:
        bus = smbus.SMBus(1)                                              # Чтение освещености  с датчика TSL2561
        bus.write_byte_data(0x39, 0x00 | 0x80, 0x03)
        time.sleep(0.5)
        data = bus.read_i2c_block_data(0x39, 0x0C | 0x80, 2)
        data1 = bus.read_i2c_block_data(0x39, 0x0E | 0x80, 2)
        ch0 = data[1] * 256 + data[0]
        ch1 = data1[1] * 256 + data1[0]
        lux_0 = str(ch0 - ch1)
        str_send_tmp = str_send_tmp+' Lx='+lux_0+'\n'
    file_cfg.close()                                                      # Закрытие файла конфигурации
    return  str_send_tmp                                                  # Возврат строки
 
# Создание строки смс с конфигуацией кросс платы
def str_sms_info2():
    file_cfg =open('/home/pi/myproject/html/logs/config.txt','r')         # Открытие файла конфигурации
    tmp_cfg = file_cfg.readlines()                                        # Чтение всех строк файла конфигурации
    if int(tmp_cfg[0]) == 1:                                              
        str_send_tmp = ' Term1=On\n'                                      # Состояние термостата № 1
    if int(tmp_cfg[0]) == 0:
        str_send_tmp = ' Term1=Off\n'
    str_send_tmp = str_send_tmp+' Term1Min='+tmp_cfg[1].rstrip()+'\n'     # Температура включения термостата № 1
    str_send_tmp = str_send_tmp+' Term1Max='+tmp_cfg[2].rstrip()+'\n'     # Температура отключения термостата № 1
    if int(tmp_cfg[3]) == 1:
        str_send_tmp = str_send_tmp+' Term2=On\n'                         # Состояние термостата № 2
    if int(tmp_cfg[3]) == 0:
        str_send_tmp = str_send_tmp+' Term2=Off\n'
    str_send_tmp = str_send_tmp+' Term2Min='+tmp_cfg[4].rstrip()+'\n'     # Температура включения термостата № 2
    str_send_tmp = str_send_tmp+' Term2Max='+tmp_cfg[5].rstrip()+'\n'		  # Температура отключения термостата № 2
    if int(tmp_cfg[24]) == 1:
        str_send_tmp = str_send_tmp+' Timer1=On\n'                        # Состояние таймера № 1
    if int(tmp_cfg[24]) == 0:
        str_send_tmp = str_send_tmp+' Timer1=Off\n'
    str_send_tmp = str_send_tmp+' Timer1Min='+tmp_cfg[25].rstrip()+'\n'   # Время включения таймера № 1
    str_send_tmp = str_send_tmp+' Timer1Max='+tmp_cfg[26].rstrip()+'\n'   # Время отключения таймера № 1
    if int(tmp_cfg[27]) == 1:
        str_send_tmp = str_send_tmp+' Timer2=On\n'                        # Состояние таймера № 2
    if int(tmp_cfg[27]) == 0:
        str_send_tmp = str_send_tmp+' Timer2=Off\n'
    str_send_tmp = str_send_tmp+' Timer2Min='+tmp_cfg[28].rstrip()+'\n'   # Время включения таймера № 2
    str_send_tmp = str_send_tmp+' Timer2Max='+tmp_cfg[29].rstrip()+'\n'   # Время отключения таймера № 1
    if int(tmp_cfg[30]) == 1:
        str_send_tmp = str_send_tmp+' Lx=On\n'                            # Состояние люксметра
    if int(tmp_cfg[30]) == 0:
        str_send_tmp = str_send_tmp+' Lx=Off\n'
    str_send_tmp = str_send_tmp+' LxMin='+tmp_cfg[31].rstrip()+'\n'       # Порог освещености включения люксметра
    str_send_tmp = str_send_tmp+' LxMax='+tmp_cfg[32].rstrip()+'\n'       # Порог освещености отключения люксметра
    if int(tmp_cfg[33]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #1=On\n'                    # Состояние датчика температуры DS18B20 № 1
    if int(tmp_cfg[33]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #1=Off\n'
    if int(tmp_cfg[34]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #2=On\n'
    if int(tmp_cfg[34]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #2=Off\n'
    if int(tmp_cfg[35]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #3=On\n'
    if int(tmp_cfg[35]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #3=Off\n'
    if int(tmp_cfg[36]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #4=On\n'
    if int(tmp_cfg[36]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #4=Off\n'
    if int(tmp_cfg[37]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #5=On\n'
    if int(tmp_cfg[37]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #5=Off\n'
    if int(tmp_cfg[38]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #6=On\n'
    if int(tmp_cfg[38]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #6=Off\n'
    if int(tmp_cfg[39]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #7=On\n'
    if int(tmp_cfg[39]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #7=Off\n'
    if int(tmp_cfg[40]) == 1:
        str_send_tmp = str_send_tmp+' DS18B20 #8=On\n'                    # Состояние датчика температуры DS18B20 № 8
    if int(tmp_cfg[40]) == 0:
        str_send_tmp = str_send_tmp+' DS18B20 #8=Off\n'                   
    if int(tmp_cfg[43]) == 1:
        str_send_tmp = str_send_tmp+' DHT22 #1=On\n'                      # Состояние датчика температуры и влажности с датчика DHT22 №1
    if int(tmp_cfg[43]) == 0:
        str_send_tmp = str_send_tmp+' DHT22 #1=Off\n'
    if int(tmp_cfg[44]) == 1:
        str_send_tmp = str_send_tmp+' DHT22 #2=On\n'                      # Состояние датчика температуры и влажности с датчика DHT22 №2
    if int(tmp_cfg[44]) == 0:
        str_send_tmp = str_send_tmp+' DHT22 #2=Off\n'
    if int(tmp_cfg[45]) == 1:
        str_send_tmp = str_send_tmp+' SHT21=On\n'                         # Состояние датчика датчика температуры и влажности SHT21
    if int(tmp_cfg[45]) == 0:
        str_send_tmp = str_send_tmp+' SHT21=Off\n'
    if int(tmp_cfg[46]) == 1:
        str_send_tmp = str_send_tmp+' TSL2561=On\n'                       # Состояние датчика освещености TSL2561
    if int(tmp_cfg[46]) == 0:
        str_send_tmp = str_send_tmp+' TSL2561=Off\n'
    if int(tmp_cfg[47]) == 1:
        str_send_tmp = str_send_tmp+' MMA7660=On\n'                       # Состояние акселерометра MMA7660
    if int(tmp_cfg[47]) == 0:
        str_send_tmp = str_send_tmp+' MMA7660=Off\n'
    if int(tmp_cfg[48]) == 1:
        str_send_tmp = str_send_tmp+' RS485=On'                           # Состояние итерфейса RS485
    if int(tmp_cfg[48]) == 0:
        str_send_tmp = str_send_tmp+' RS485=Off'
    file_cfg.close()                                                      # Закрытие файла конфигурации                                              
    return  str_send_tmp                                                  # Возврат строки

# Создание строки смс с логом gpio по дате
def str_sms_info3(str_date):
    file_gpio =open('/home/pi/myproject/html/logs/log_gpio.txt','r')      # Открытие файла лога GPIO
    str_send_tmp = 'date\n'                                               # Формирование строки
    for tmp_gpio in file_gpio.readlines():                                # Цикл чтения строк 
        tmp_date = tmp_gpio[:10]                                          # Чтение даты из строки
        if tmp_date == str_date:                                          # если дата строки совпадает
            str_send_tmp = str_send_tmp + tmp_gpio+'\n'                   # добавление в строку данных
            continue
    file_gpio.close()                                                     # Закрытие файла лога GPIO                                              
    return  str_send_tmp                                                  # Возврат строки

# Создание строки смс с логом gpio по дате
def str_sms_info4():
    file_cfg =open('/home/pi/myproject/html/logs/config_sms.txt','r')     # Открытие файла конфигурации
    tmp_cfg = file_cfg.readlines()                                        # Чтение всех строк файла конфигурации
    if int(tmp_cfg[0]) == 1:                                              
        str_send_tmp = ' Security=On\n'                                   # Состояние сигнализации
    if int(tmp_cfg[0]) == 0:
        str_send_tmp = ' Security=Off\n'
    if int(tmp_cfg[1]) == 1:
        str_send_tmp = str_send_tmp+' AlarmZona1\n'                       # Состояние первой линии сигнализации
    if int(tmp_cfg[1]) == 0:
        str_send_tmp = str_send_tmp+' NoAlarmZona1\n'
    if int(tmp_cfg[2]) == 1:
        str_send_tmp = str_send_tmp+' AlarmZona2\n'                       # Состояние второй линии сигнализации
    if int(tmp_cfg[2]) == 0:
        str_send_tmp = str_send_tmp+' NoAlarmZona2\n'
    if int(tmp_cfg[3]) == 1:
        str_send_tmp = str_send_tmp+' AlarmElec\n'                        # Состояние электоролинии
    if int(tmp_cfg[3]) == 0:
        str_send_tmp = str_send_tmp+' NoAlarmElec\n'
    if int(tmp_cfg[4]) == 1:                                              
        str_send_tmp = str_send_tmp+' In5Open\n'                          # Состояние входа №5
    if int(tmp_cfg[4]) == 0:
        str_send_tmp = str_send_tmp+' In5Close\n'
    if int(tmp_cfg[5]) == 1:
        str_send_tmp = str_send_tmp+' In6Open\n'                          # Состояние входа №6
    if int(tmp_cfg[5]) == 0:
        str_send_tmp = str_send_tmp+' In6Close\n'
    if int(tmp_cfg[6]) == 1:
        str_send_tmp = str_send_tmp+' In7Open\n'                          # Состояние входа №7
    if int(tmp_cfg[6]) == 0:
        str_send_tmp = str_send_tmp+' In7Close\n'
    if int(tmp_cfg[7]) == 1:
        str_send_tmp = str_send_tmp+' In8Open\n'                          # Состояние входа №8
    if int(tmp_cfg[7]) == 0:
        str_send_tmp = str_send_tmp+' In8Close\n'
    str_send_tmp = str_send_tmp+' PauseOnSec='+tmp_cfg[8].rstrip()+'\n'   # Пауза перед включением сигнализации
    file_cfg.close()     
    return  str_send_tmp                                                  # Возврат строки
  
# Генерация уникального ID
def id_generator(size=6, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size))

# Создание файла смс 
def send_sms(str_phone, str_sms):
    f_send_name = str_phone+'_'                                           # Генерация уникального имени файла
    f_send_name = f_send_name+id_generator()
    f_sms_send = open(folder_log+f_send_name, 'a')                        # Создание файла
    f_sms_send.write('To: '+str_phone+'\n')                               # Формирование текста файла
    f_sms_send.write('\n')
    f_sms_send.write(str_sms)
    f_sms_send.close()                                                    # Закрытие файла смс
    shutil.move(folder_log+f_send_name, folder_send_sms+f_send_name)      # Перемещение на отправку

# Установка команды 
def set_command(num_str_cfg, str_command):
    lines_index = []
    file_cfg =open('/home/pi/myproject/html/logs/config.txt','r')         # Открытие файла конфигурации
    line = file_cfg.readlines()                                           # Чтение всех строк файла конфигурации
    line[int(num_str_cfg)] = str_command+'\n'                             # Изменение нужной строки файла конфигурации
    file_cfg.close()                                                      # Закрытие файла конфигурации
    file_cfg =open('/home/pi/myproject/html/logs/config.txt','w')         # Открытие файла конфигурации на запись
    file_cfg.writelines(line)                                             # Запись всех строк файла конфигурации
    file_cfg.close()                                                      # Закрытие файла конфигурации

# Запись данных  в лог файл
def set_log(str_file, str_phone, str_command):
    f_log = open(folder_log+'log_sms.txt', 'a')                           # Открытие файла лога смс
    str_log = "{0},{1}\n".format(strftime("%d-%m-%Y %H:%M:%S"),'FileSMS='+str_file+' PhoneSMS='+str_phone+' CommandSMS='+str_command ) # Формирование строки 
    f_log.write(str_log)                                                  # Запись строки
    f_log.close()                                                         # Закрытие файла лога смс

# Запись состояния входов сигнализации 
def set_conf_sms(num_str_cfg, str_command):
    file_cfg =open('/home/pi/myproject/html/logs/config_sms.txt','r')     # Открытие файла конфигурации
    line = file_cfg.readlines()                                           # Чтение всех строк файла конфигурации
    line[int(num_str_cfg)] = str_command+'\n'                             # Изменение нужной строки файла конфигурации
    file_cfg.close()                                                      # Закрытие файла конфигурации
    file_cfg =open('/home/pi/myproject/html/logs/config_sms.txt','w')     # Открытие файла конфигурации на запись
    file_cfg.writelines(line)                                             # Запись всех строк файла конфигурации
    file_cfg.close()                                                      # Закрытие файла конфигурации

# Чтение состояния входов сигнализации 
def get_conf():
    if os.path.exists('/home/pi/myproject/html/logs/config_sms.txt'):
        file_cfg =open('/home/pi/myproject/html/logs/config_sms.txt','r')     # Открытие файла конфигурации
        line = file_cfg.readlines()                                           # Чтение всех строк файла конфигурации
        file_cfg.close()                                                      # Закрытие файла конфигурации 
    else:
        f = open('/home/pi/myproject/html/logs/config_sms.txt', 'w')          # Если файла не существует создаем его
        line = [0,0,0,0,0,0,0,0,60,0,0,0,0,0]                                     # Конфигурация поумолчанию
        f.writelines("%s\n" % i for i in line)                                # Запись конфигурации
        f.close()
    if os.path.getsize('/home/pi/myproject/html/logs/config_sms.txt') == 0:   # Если файл испорчен создаем его по новому
        f = open('/home/pi/myproject/html/logs/config_sms.txt', 'w')
        line = [0,0,0,0,0,0,0,0,60,0,0,0,0,0]
        f.writelines("%s\n" % i for i in line)
        f.close()
    return line

# Кнопка включения сигнализации c триггер удерживать 5 секунд (время цикла)
def read_in1():
    line = get_conf() 
    if int(line[0]) == 1:
        GPIO.digitalWrite(8, GPIO.LOW)                                    # Включение выхода №6 охрана  
    if (int(GPIO.digitalRead(23))) == 0:                                  # Кнопка замкнута
        if (int(GPIO.digitalRead(8))) == 0:                               # Выход №6 включен 
            GPIO.digitalWrite(8, GPIO.HIGH)                               # Отключение выхода №6 снятие с охраны
            set_conf_sms('0', '0')                                        # Запись в файл конфигурации отключения сигнализации
            set_conf_sms('1', '0')                                        # Запись в файл конфигурации сброс флага тревоги линии №1
            set_conf_sms('2', '0')                                        # Запись в файл конфигурации сброс флага тревоги линии №2
            set_conf_sms('3', '0')                                        # Запись в файл конфигурации сброс флага контроля  электролинии
            set_conf_sms('11', '0')                                       # Запись в файл конфигурации сброс флага отправки смс линии №1
            set_conf_sms('12', '0')                                       # Запись в файл конфигурации сброс флага отправки смс линии №2
            set_conf_sms('13', '0')                                       # Запись в файл конфигурации сброс флага отправки смс контроля  электролинии   
        else:                                                             # Иначе
            GPIO.digitalWrite(8, GPIO.LOW)                                # Включение выхода №6 охрана
            set_conf_sms('0', '1')                                        # Запись в файл конфигурации  включения сигнализации
            set_conf_sms('10', '0')                                       # Запись в файл конфигурации  сброс флага конца паузы
            set_conf_sms('9', '0')                                        # Запись в файл конфигурации  обнуление текушего времени установки паузы  

# Примитивный таймер паузы для того чтобы владелец успел покинуть помещение после вкюлчения сигнализации
def timer_pause():
    if (int(GPIO.digitalRead(8))) == 0:                                   # Сигнализация включена
        line = get_conf()                                                 # Чтение файла кофигурации
        if int(line[10]) == 0:                                            # флаг конца паузы не установлен
            if int(line[8]) > int(line[9]):                               # текушее время меньше заданного
                time_tmp = str(int(line[9]) +5)                           # увеличение счетчика на 5 секунд (время цикла)
                set_conf_sms('9', time_tmp)                               # сохранение нового результата текущего времени
            else:                                                         # Иначе 
                set_conf_sms('10', '1')                                   # Устанавка флага конца паузы
                                                                                            

# Вход №2 замкнутый нормалный, разомкнутый тревога
def read_in2():
    if (int(GPIO.digitalRead(8))) == 0:                                   # Сигнализация включена
        line = get_conf()                                                 # Чтение файла кофигурации
        if int(line[10]) == 1:                                            # Флаг конца паузы установлен
            if (int(GPIO.digitalRead(18))) == 1:                          # Контакты разомкнуты тревога
                set_conf_sms('1', '1')                                    # Устанавка флага тревоги линии №1  
            else:                                                         # Иначе
                set_conf_sms('1', '0')                                    # Сброс флага тревоги линии №1

# Вход №3 замкнутый тревога, разомкнутый нормалный
def read_in3():
    if (int(GPIO.digitalRead(8))) == 0:                                   # Сигнализация включена
        line = get_conf()                                                 # Чтение файла кофигурации
        if int(line[10]) == 1:                                            # Флаг конца паузы установлен
            if (int(GPIO.digitalRead(22))) == 0:                          # Контакты замкнуты тревога
                set_conf_sms('2', '1')                                    # Устанавка флага тревоги линии №2  
            else:                                                         # Иначе
                set_conf_sms('2', '0')                                    # Сброс флага тревоги линии №2

# Вход №4 замкнутый электролиния в порядке, разомкнутый нет питания на электролинии
def read_in4():
    if (int(GPIO.digitalRead(8))) == 0:                                   # Сигнализация включена
        if (int(GPIO.digitalRead(5))) == 1:                               # Контакты разомкнуты нет питания на электролинии
            set_conf_sms('3', '1')                                        # Устанавка флага нет питания на электролинии 
        else:                                                             # Иначе
            set_conf_sms('3', '0')                                        # Сброс флага нет питания на электролинии

# Чтение состояния входов с 5 по 8
def read_in5_8():
    if (int(GPIO.digitalRead(6))) == 1:                                   # Контакты входа №5 разомкнуты 
        set_conf_sms('4', '1')                                            # Устанавка флага состояния входа №5
    else:                                                                 # Иначе
        set_conf_sms('4', '0')                                            # Сброс флага состояния входа №5
    if (int(GPIO.digitalRead(13))) == 1:                                  # Контакты входа №6 разомкнуты 
        set_conf_sms('5', '1')                                            # Устанавка флага состояния входа №6
    else:                                                                 # Иначе
        set_conf_sms('5', '0')                                            # Сброс флага состояния входа №6
    if (int(GPIO.digitalRead(19))) == 1:                                  # Контакты входа №7 разомкнуты 
        set_conf_sms('6', '1')                                            # Устанавка флага состояния входа №7
    else:                                                                 # Иначе
        set_conf_sms('6', '0')                                            # Сброс флага состояния входа №7
    if (int(GPIO.digitalRead(26))) == 1:                                  # Контакты входа №8 разомкнуты 
        set_conf_sms('7', '1')                                            # Устанавка флага состояния входа №8
    else:                                                                 # Иначе
        set_conf_sms('7', '0')                                            # Сброс флага состояния входа №8


# Создает с отсылает смс по всем талефонам
def send_sms_alarm(str_send, str_tmp):
    f_phones = open('/home/pi/myproject/html/logs/phones.txt', 'r')
    for str_phone in f_phones.readlines():		                          # Чтение списка телефонов
        str_phone = str_phone.rstrip()		                              # Удаление символа перевода строки
        send_sms(str_phone, str_send)	                                  # Создание  файла смс и перемещение его на отправку	
        set_log('NoFile',str_phone,str_tmp)                               # Запись данных  в лог файл	
    f_phones.close()

# Проверка срабатывания сигнализации
def check_sms_alarm():
    if (int(GPIO.digitalRead(8))) == 0:                                   # Сигнализация включена
        line = get_conf()                                                 # Чтение файла кофигурации
        if int(line[10]) == 1:                                            # Флаг конца паузы установлен    
            if int(line[11]) == 0:                                        # Флаг отправки смс сброшен
                if int(line[1]) == 1:                                     # Флаг тревоги линии №1 установлен                
                    send_sms_alarm('AlarmZona1', 'Security=On')           # Создание с отсылка смс 
                    set_conf_sms('11', '1')                               # Установка Флага отправки смс
            if int(line[12]) == 0:                                        # Флаг отправки смс сброшен
                if int(line[2]) == 1:                                     # Флаг тревоги линии №2 установлен                
                    send_sms_alarm('AlarmZona2', 'Security=On')           # Создание с отсылка смс 
                    set_conf_sms('12', '1')                               # Установка Флага отправки смс
            if int(line[13]) == 0:                                        # Флаг отправки смс сброшен
                if int(line[3]) == 1:                                     # Флаг тревоги линии №1 установлен                
                    send_sms_alarm('AlarmElec', 'Security=On')            # Создание с отсылка смс 
                    set_conf_sms('13', '1')                               # Установка Флага отправки смс


def loop():
    files_receive_sms = os.listdir(folder_receive_sms)	# Список файлов смс
    for line in files_receive_sms:				              # Цикл обработки принятых смс
        file_sms = line					                        # Имя файла смс	
        f_sms = open(folder_receive_sms+file_sms)	      # Открытие файла смс
        str_phone = f_sms.readline()                    # Чтение телефонного номера отправителя из смс
        str_phone = str_phone[6:]                       # Чтение телефонного номера из строки
        str_phone = str_phone.rstrip()			            # Удаление символа перевода строки
        count_str  = len(str_phone)			                # Длинна строки с номером отправителя
        f_tmp = f_sms.readlines()			                  # Чтение всех строк смс
        str_tmp = f_tmp[11]				                      # Чтение строки смс с сообщением
        str_tmp = str_tmp.rstrip()			                # Удаление символа перевода строки
        count_tmp  = len(str_tmp)			                  # Длинна строки с сообщением
        f_sms.close()					                          # Закрытие файла смс
        if count_str == 0:				                      # удаление смс не соответсвующие формату (системные сообщения от провайдера и прочее)
            os.remove(folder_receive_sms+file_sms)	    # Длинна строки с номером отправителя равна нулю
            continue
        if count_str < 11:
            os.remove(folder_receive_sms+file_sms)	    # Длинна строки с номером отправителя меньше 11 символов (длинна номера 11 символов)
            continue
        if count_tmp > 20:
            os.remove(folder_receive_sms+file_sms)	    # Длинна строки с сообщением отправителя больше 20 символов (размер команд)
            continue
        f_phones = open('/home/pi/myproject/html/logs/phones.txt', 'r')
        for str_temp in f_phones.readlines():		            # Чтение списка телефонов
            str_temp = str_temp.rstrip()		                # Удаление символа перевода строки
            if str_temp == str_phone:			                  # Сравнение телефона со списком
                if str_tmp == "I=1?":			                  # Декодирование команды запроса на информацию №1
                    str_send = str_sms_info1() 	            # Создание строки смс запроса на информацию №1
                    send_sms(str_phone, str_send)	          # Создание  файла смс и перемещение его на отправку
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_tmp == "I=2?":			                  # Декодирование команды запроса на информацию №2
                    str_send = str_sms_info2() 	            # Создание строки смс  запроса на информацию №2
                    send_sms(str_phone, str_send)	          # Создание  файла смс и перемещение его на отправку	
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл				
                    continue
                str_x = str_tmp[:4]			                    # Извлечение команды из строки
                str_y = str_tmp[5:]			                    # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == "I=3?":			                    # Декодирование команды запроса на информацию №3
                    str_send = str_sms_info3(str_y) 	      # Создание строки смс  запроса на информацию №3
                    send_sms(str_phone, str_send)	          # Создание  файла смс и перемещение его на отправку	
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл				
                    continue
                if str_tmp == "I=4?":			                  # Декодирование команды запроса на информацию №4
                    str_send = str_sms_info4() 	            # Создание строки смс  запроса на информацию №4
                    send_sms(str_phone, str_send)	          # Создание  файла смс и перемещение его на отправку	
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл				
                    continue
                if str_tmp == 'C=Term1On':		              # Декодирование команды включение термостата №1
                    set_command('0', '1') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_tmp == 'C=Term1Off':		              # Декодирование команды отключение термостата №1
                    set_command('0', '0') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    GPIO.digitalWrite(21, GPIO.HIGH)        # Отключение канала №1 
                    continue
                str_x = str_tmp[:10]			                  # Извлечение команды из строки
                str_y = str_tmp[11:]			                  # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=Term1Min':		                # Декодирование команды температура включения термостата №1
                    set_command('1', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_x == 'C=Term1Max':		                # Декодирование команды температура отключения термостата №1
                    set_command('2', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_tmp == 'C=Term2On':		              # Декодирование команды включение термостата №2
                    set_command('3', '1') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_tmp == 'C=Term2Off':		              # Декодирование команды отключение термостата №2
                    set_command('3', '0') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    GPIO.digitalWrite(20, GPIO.HIGH)        # Отключение канала №2
                    continue
                if str_x == 'C=Term2Min':		                # Декодирование команды температура включения термостата №2
                    set_command('4', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_x == 'C=Term2Max':		                # Декодирование команды температура отключения термостата №2
                    set_command('5', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                if str_tmp == 'C=Timer1On':		              # Декодирование команды включение таймера №1
                    set_command('24', '1') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Timer1Off':		            # Декодирование команды отключение таймера №1
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    set_command('24', '0') 		              # Запись команды в файл конфигурации
                    GPIO.digitalWrite(16, GPIO.HIGH)        # Отключение канала №3
                    continue
                str_x = str_tmp[:13]			                  # Извлечение команды из строки
                str_y = str_tmp[14:]			                  # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=Timer1Start':		            # Декодирование команды старт таймера №1
                    set_command('25', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                str_x = str_tmp[:12]			                  # Извлечение команды из строки
                str_y = str_tmp[13:]			                  # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=Timer1Stop':		              # Декодирование команды стоп таймера №1
                    set_command('26', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue                 
                if str_tmp == 'C=Timer2On':		              # Декодирование команды включение таймера №2
                    set_command('27', '1') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Timer2Off':		            # Декодирование команды отключение таймера №2
                    set_command('27', '0') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    GPIO.digitalWrite(12, GPIO.HIGH)        # Отключение канала №4 
                    continue
                str_x = str_tmp[:13]			                  # Извлечение команды из строки
                str_y = str_tmp[14:]			                  # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=Timer2Start':		            # Декодирование команды старт таймера №2
                    set_command('28', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp) 
                    continue
                str_x = str_tmp[:12]			                  # Извлечение команды из строки
                str_y = str_tmp[13:]			                  # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=Timer2Stop':		              # Декодирование команды стоп таймера №2
                    set_command('29', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=LxOn':		                  # Декодирование команды включение люксметра
                    set_command('30', '1') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=LxOff':		                # Декодирование команды отключение люксметра
                    set_command('30', '0') 		              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    GPIO.digitalWrite(7, GPIO.HIGH)         # Отключение канала №5 
                    continue
                str_x = str_tmp[:7]			                    # Извлечение команды из строки
                str_y = str_tmp[8:]			                    # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=LxMin':		                  # Декодирование команды порог включения люксметра
                    set_command('31', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_x == 'C=LxMax':		                  # Декодирование команды порог отключения люксметра
                    set_command('32', str_y) 	              # Запись команды в файл конфигурации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл
                    continue
                file_cfg =open('/home/pi/myproject/html/logs/config.txt','r')
                line = file_cfg.readlines()
                if str_tmp == 'C=Out1On':		            # Декодирование команды включение выхода №1
                    if int(line[0]) == 0:
                        GPIO.digitalWrite(21, GPIO.LOW)     # Включение канала №1 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out1Off':		            # Декодирование команды отключение  выхода №1
                    if int(line[0]) == 0:
                        GPIO.digitalWrite(21, GPIO.HIGH)    # Отключение канала №1 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out2On':		            # Декодирование команды включение выхода №2
                    if int(line[3]) == 0:
                        GPIO.digitalWrite(20, GPIO.LOW)     # Включение канала №2 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out2Off':		            # Декодирование команды отключение  выхода №2
                    if int(line[3]) == 0:
                        GPIO.digitalWrite(20, GPIO.HIGH)    # Отключение канала №2 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out3On':		            # Декодирование команды включение выхода №3
                    if int(line[24]) == 0:
                        GPIO.digitalWrite(16, GPIO.LOW)     # Включение канала №3 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out3Off':		            # Декодирование команды отключение  выхода №3
                    if int(line[24]) == 0:
                        GPIO.digitalWrite(16, GPIO.HIGH)    # Отключение канала №3 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out4On':		            # Декодирование команды включение выхода №4
                    if int(line[27]) == 0:
                        GPIO.digitalWrite(12, GPIO.LOW)     # Включение канала №4 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out4Off':		            # Декодирование команды отключение  выхода №4
                    if int(line[27]) == 0:
                        GPIO.digitalWrite(12, GPIO.HIGH)    # Отключение канала №4 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out5On':		            # Декодирование команды включение выхода №5
                    if int(line[30]) == 0:
                        GPIO.digitalWrite(7, GPIO.LOW)      # Включение канала №5
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out5Off':		            # Декодирование команды отключение  выхода №5
                    if int(line[30]) == 0:
                        GPIO.digitalWrite(7, GPIO.HIGH)     # Отключение канала №5 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out6On':		            # Декодирование команды включение выхода №6
                    GPIO.digitalWrite(8, GPIO.LOW)          # Включение канала №4
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out6Off':		            # Декодирование команды отключение  выхода №6
                    GPIO.digitalWrite(8, GPIO.HIGH)         # Отключение канала №6 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out7On':		            # Декодирование команды включение выхода №7
                    if int(line[6]) == 0:
                        GPIO.digitalWrite(25, GPIO.LOW)     # Включение канала №7
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out7Off':		            # Декодирование команды отключение  выхода №7
                    if int(line[6]) == 0:
                        GPIO.digitalWrite(25, GPIO.HIGH)    # Отключение канала №7 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out8On':		            # Декодирование команды включение выхода №8
                    if int(line[7]) == 0:
                        GPIO.digitalWrite(24, GPIO.LOW)     # Включение канала №8
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=Out8Off':		            # Декодирование команды отключение  выхода №8
                    if int(line[7]) == 0:
                        GPIO.digitalWrite(24, GPIO.HIGH)    # Отключение канала №8 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue	
                file_cfg.close()
                if str_tmp == 'C=SecOn':		            # Декодирование команды включения сигнализации
                    set_conf_sms('0', '1')                  # Запись в файл конфигурации  включения сигнализации
                    set_conf_sms('10', '0')                 # Запись в файл конфигурации  сброс флага конца паузы
                    set_conf_sms('9', '0')                  # Запись в файл конфигурации  обнуление текушего времени установки паузы                      
                    GPIO.digitalWrite(8, GPIO.LOW)          # Включение канала включения сигнализации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                if str_tmp == 'C=SecOff':		            # Декодирование команды отключение сигнализации
                    set_conf_sms('0', '0')                  # Запись в файл конфигурации отключение сигнализации
                    set_conf_sms('1', '0')                  # Запись в файл конфигурации сброс флага тревоги линии №1
                    set_conf_sms('2', '0')                  # Запись в файл конфигурации сброс флага тревоги линии №2
                    set_conf_sms('3', '0')                  # Запись в файл конфигурации сброс флага контроля  электролинии
                    set_conf_sms('11', '0')                 # Запись в файл конфигурации сброс флага отправки смс линии №1
                    set_conf_sms('12', '0')                 # Запись в файл конфигурации сброс флага отправки смс линии №2
                    set_conf_sms('13', '0')                 # Запись в файл конфигурации сброс флага отправки смс контроля  электролинии 
                    GPIO.digitalWrite(8, GPIO.HIGH)         # Отключение сигнализации 
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
                str_x = str_tmp[:12]			            # Извлечение команды из строки
                str_y = str_tmp[13:]			            # Извлечение данных из строки
                str_y = str_y.rstrip()
                if str_x == 'C=PauseOnSec':		        # Декодирование команды отключение сигнализации
                    set_conf_sms('8', str_y)                # Запись в файл конфигурации отключение сигнализации
                    set_log(file_sms,str_phone,str_tmp)     # Запись данных  в лог файл 
                    continue
        f_phones.close()                                # Закрытие файла с телефонами
        os.remove(folder_receive_sms+file_sms)          # Удаление обработанного файла
    read_in1()
    timer_pause()
    read_in2()
    read_in3()
    read_in4()
    read_in5_8()
    check_sms_alarm()
    webiopi.sleep(5)                                   # пауза 5 секунд

